import com.baomidou.mybatisplus.annotation.DbType;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.core.toolkit.StringPool;
import com.baomidou.mybatisplus.generator.AutoGenerator;
import com.baomidou.mybatisplus.generator.InjectionConfig;
import com.baomidou.mybatisplus.generator.config.DataSourceConfig;
import com.baomidou.mybatisplus.generator.config.FileOutConfig;
import com.baomidou.mybatisplus.generator.config.GlobalConfig;
import com.baomidou.mybatisplus.generator.config.PackageConfig;
import com.baomidou.mybatisplus.generator.config.StrategyConfig;
import com.baomidou.mybatisplus.generator.config.TemplateConfig;
import com.baomidou.mybatisplus.generator.config.po.TableInfo;
import com.baomidou.mybatisplus.generator.config.rules.NamingStrategy;
import com.baomidou.mybatisplus.generator.engine.FreemarkerTemplateEngine;

import java.util.ArrayList;
import java.util.List;

/**
 * @ClassName：Generator
 * @Description：代码自动生成器
 */
public class CodeGeneratorMYSQLPlus {
    static String baseOutputDir = "./signal-optimize-service";
    static String subModulePackage = ".report";

    public static void main(String[] args) {
        // 生成地址 : // System.getProperty("user.dir") == 得到当前项目的实际地址
        String outputDir = System.getProperty("user.dir") + "/src/main/java";

        outputDir = baseOutputDir + "/src/main/java";

        System.out.println(outputDir);
        // 表名, 注意大小写
        String[] tableNames = new String[]{"t_analysis_report_cross_optimize_detail"};
        // 数据库地址
        String url = "jdbc:mysql://localhost:3306/wjdit_ecosystem_db_v1.0.0?serverTimezone=Asia/Shanghai&useUnicode=true&useSSL=false&characterEncoding=utf8";

        // 用户名
        String userName = "root";
        // 密码
        String password = "123456";
        // 父包路径
        String parentPackage = "net.wanji.opt";
        // 需要去掉的表名前缀
        String prefixTable = "t_";
        generate(outputDir, tableNames, url, userName, password, parentPackage, prefixTable);
    }

    /**
     * @param outputDir     生成地址
     * @param tableNames    表名
     * @param url           数据库地址
     * @param userName      用户名
     * @param password      密码
     * @param parentPackage 父包路径
     * @param prefixTable   需要去掉的表名前缀
     */
    public static void generate(String outputDir, String[] tableNames, String url, String userName,
                                String password, String parentPackage, String prefixTable) {
        // ===============  全局配置  ==================
        GlobalConfig gc = new GlobalConfig();
        gc.setOutputDir(outputDir)
                .setActiveRecord(false)                                // 是否支持 AR, 实体类只需继承 Model 类即可进行强大的 CRUD 操作
                .setAuthor("fengyi")                            // 设置作者名字
                .setFileOverride(true)                                // 文件覆盖(全新文件)
                .setIdType(IdType.AUTO)                                // 主键策略
                .setBaseResultMap(true)                            // SQL 映射文件
                .setBaseColumnList(true)                            // SQL 片段
                .setServiceName("%sService")                        // service的名字
                .setMapperName("%sMapper")
                .setOpen(false);

        // =================  数据源配置   ===============
        DataSourceConfig dsc = new DataSourceConfig();
        dsc.setDbType(DbType.MYSQL)
                .setDriverName("com.mysql.jdbc.Driver");
        dsc.setUrl(url)
                .setUsername(userName)
                .setPassword(password);

        // =================  包配置  ===================
        PackageConfig pc = new PackageConfig();
        pc.setParent(parentPackage)                            // 配置父包路径
//           .setModuleName("base")								// 配置业务包路径
                .setMapper("dao.mapper" + subModulePackage)
                .setEntity("entity" + subModulePackage)
                .setService("servicev2" + subModulePackage)
                .setServiceImpl("servicev2" + subModulePackage + ".impl")                    // 会自动生成 impl，可以不设定
                .setController("controllerv2" + subModulePackage);

        // ==================  自定义配置  =================
        InjectionConfig cfg = new InjectionConfig() {
            @Override
            public void initMap() {
                // to do nothing
            }
        };
        List<FileOutConfig> focList = new ArrayList<>();
        // 调整 xml 生成目录演示
        focList.add(new FileOutConfig("/templates/mybatisplus/mapper.xml.ftl") {
            @Override
            public String outputFile(TableInfo tableInfo) {
                // 自定义输入文件名称
                return baseOutputDir + "/src/main/resources/mapper/" + subModulePackage.substring(1) + "/"
                        + tableInfo.getEntityName() + "Mapper" + StringPool.DOT_XML;
            }
        });
        cfg.setFileOutConfigList(focList);

        // ===================  策略配置  ==================
        StrategyConfig strategy = new StrategyConfig();
        strategy.setNaming(NamingStrategy.underline_to_camel)                    // 表名命名：  underline_to_camel 底线变驼峰
                .setColumnNaming(NamingStrategy.underline_to_camel)            // 字段命名： underline_to_camel 底线变驼峰
                .setInclude(tableNames)                                        // 需要生成的 表名
                .setCapitalMode(true)                                            // 全局大写命名 ORACLE 注意
                .setTablePrefix(prefixTable)                                    // 去掉 表的前缀
//                 .setFieldPrefix(pc.getModuleName() + "_")					// 去掉字段前缀
//                 .setSuperEntityClass("com.maoxs.pojo")						// 继承类
//                 .setSuperControllerClass("com.maoxs.controller")				// 继承类
//                 .setSuperEntityColumns("id") 								// 设置超级超级列
                .setEntityLombokModel(true)                                    // 是否加入lombok
                .setControllerMappingHyphenStyle(true)                        // 设置controller映射联字符
                .setRestControllerStyle(true)
        ;
        //自动填充字段,在项目开发过程中,例如创建时间，修改时间,每次，都需要我们来指定，太麻烦了,设置为自动填充规则，就不需要我们赋值咯
//         List<TableFill> list = new ArrayList<TableFill>();
//         TableFill tableFill1 = new TableFill("register_date",FieldFill.INSERT);
//         TableFill tableFill2 = new TableFill("update_time",FieldFill.INSERT_UPDATE);
//         list.add(tableFill1);
//         list.add(tableFill2);
//         strategy.setTableFillList(list);

        // ==================  自定义模板配置： 默认配置位置 mybatis-plus/src/main/resources/templates  ======================
        // 放置自己项目的 src/main/resources/templates 目录下, 默认名称一下可以不配置，也可以自定义模板名称
        TemplateConfig tc = new TemplateConfig();
        tc.setXml("/templates/mybatisplus/mapper.xml")                                                        // 设置生成xml的模板
                .setEntity("/templates/mybatisplus/entity.java")                                // 设置生成entity的模板
                .setMapper("/templates/mybatisplus/mapper.java")                                // 设置生成mapper的模板
                .setController("/templates/mybatisplus/controller.java")                    // 设置生成controller的模板
                .setService("/templates/mybatisplus/service.java")                            // 设置生成service的模板
                .setServiceImpl("/templates/mybatisplus/serviceImpl.java")                    // 设置生成serviceImpl的模板


        ;
        // ====================  生成配置  ===================
        AutoGenerator mpg = new AutoGenerator();
        mpg.setCfg(cfg)
                .setTemplate(tc)
                .setGlobalConfig(gc)
                .setDataSource(dsc)
                .setPackageInfo(pc)
                .setStrategy(strategy)
                .setTemplateEngine(new FreemarkerTemplateEngine());            // 选择 freemarker引擎，注意 pom 依赖必须有！
        mpg.execute();
        System.out.println("MyBatis Plus Code Generator Finished!!");
    }

}
